function Spectator:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end



function Spectator:StartActivity()
	print("START! -- SkirmishDefense:StartActivity()!");
	self.playertally = 0;
	self.playerlist = {};
  	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        	if self:PlayerActive(player) and self:PlayerHuman(player) then
			self.playerlist[player + 1] = true;
			self.playertally = self.playertally + 1;
			local ship = nil;
			ship = CreateActor("Brain Case", "Base.rte");
			ship.Team = self:GetTeamOfPlayer(player);
			local w = math.random();
			ship.Pos = Vector(w*100-50,-200);
			MovableMan:AddActor(ship);
		
			self.ActivityState = Activity.EDITING;
			-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					-- self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end
	self.WList = { "Grenade Launcher", "Blaster", "Nailgun", "Pistol", "Sniper Rifle", "Heavy Sniper Rifle", "Gatling Gun", "Flamer", "Napalm Flamer", "Spike Launcher", "Flak Cannon", "Auto Pistol", "Shotgun", "Auto Shotgun", "Mauler Shotgun", "Bazooka", "YAK47", "YAK4700", "TommyGun", "Uzi", "M16", "Shortgun", "Spaz12", "Spaz1200", "Rifle Long", "Desert Eagle", "Glock", "HAK 20", "Luger", "Peacemaker", "Lady Pistol" };
	self.AList = { "Mia", "Dafred", "Dimitri", "Gordon", "Brutus", "Sandra", "Soldier Light", "Soldier Heavy", "Browncoat Light", "Browncoat Heavy" };
	self.ESpawnTimer = Timer();
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ Team 2");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(1000000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 10000;
		self.RandomSpawnTime = 20000;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(1000000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 5500;
		self.RandomSpawnTime = 7000;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(1000000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 5000;
		self.RandomSpawnTime = 6000;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(1000000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 4500;
		self.RandomSpawnTime = 5000;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(1000000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 4000;
		self.RandomSpawnTime = 4500;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self:SetTeamFunds(1000000, Activity.TEAM_1);
		self:SetTeamFunds(1000000, Activity.TEAM_2);
		self:SetTeamFunds(100000, Activity.TEAM_3);
		self:SetTeamFunds(1000000, Activity.TEAM_4);
		self.BaseSpawnTime = 100;
		self.RandomSpawnTime = 1200;
	end

	self.StartTimer = Timer();
	self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);

	wildcard = 0;
	startInEditor = 0;
	manageMyArmy = 1;
	spawnMyEnemy = 1;
	messageType =  0;
	messageTimer = Timer();
	buttonPressed = 0;

end

function Spectator:PauseActivity(pause)
    	print("PAUSE! -- SkirmishDefense:PauseActivity()!");
end

function Spectator:EndActivity()
    	print("END! -- SkirmishDefense:EndActivity()!");
		
end

function Spectator:UpdateActivity()


	if UInputMan:KeyHeld(63) then
		startInEditor = 1;
	end
			
	if self.ActivityState ~= Activity.OVER and (self.ActivityState ~= Activity.EDITING or startInEditor == 1) then
	

		-- Clear all objective markers, they get re-added each frame
		self:ClearObjectivePoints();

		
		if buttonPressed == 0 then
			if UInputMan:KeyPressed(28) then
				if manageMyArmy == 0 then
					manageMyArmy = 1;
					messageType = 2;
				else
					manageMyArmy = 0;
					messageType = 1;
				end
				buttonPressed = 1;
				messageTimer:Reset();
			end
			if UInputMan:KeyPressed(29) then
				if spawnMyEnemy == 0 then
					spawnMyEnemy = 1;
					messageType = 4;
				else
					spawnMyEnemy = 0;
					messageType = 3;
				end
				buttonPressed = 1;
				messageTimer:Reset();
			end
		end

		if buttonPressed == 1 and (UInputMan:KeyReleased(28) or UInputMan:KeyReleased(29)) then
			buttonPressed = 0;
		end

		if messageTimer:LeftTillSimMS(4500) <= 0 then
			messageType = 0;
			messageTimer:Reset();
		end

		if messageType == 0 then
			FrameMan:SetScreenText("    Pop = " .. MovableMan:GetMOIDCount() .. "/300\n" .. "   Red vs Green\n " .. self:GetTeamDeathCount(Activity.TEAM_2) .. "       " .. self:GetTeamDeathCount(Activity.TEAM_1), Activity.PLAYER_1, 0, 1000, false);
		elseif messageType == 1 then 
			FrameMan:SetScreenText("You've just fired your assistant for no reason!\nOnly you now can order troops", Activity.PLAYER_1, 0, 1000, false);
		elseif messageType == 2 then 
			FrameMan:SetScreenText("You hire another, much classier assistant!\nThey begin ordering troops for you with careless abandon", Activity.PLAYER_1, 0, 1000, false);
		elseif messageType == 3 then 
			FrameMan:SetScreenText("The enemy has gone on Holiday!\nThier troops who remain planetside do not know how to feel", Activity.PLAYER_1, 0, 1000, false);
		elseif messageType == 4 then 
			FrameMan:SetScreenText("The enemy has begun their attack anew!\nAnd it's about time", Activity.PLAYER_1, 0, 1000, false);
		end
		





		local spawn = 0;
		if self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 300 then
			if wildcard == 0 then
				wildcard = 1;
				if manageMyArmy == 1 then
					spawn = 1;
				end
			else
				wildcard = 0;
				if spawnMyEnemy == 1 then
					spawn = 2;
				end
			end
			self.ESpawnTimer:Reset();
			self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime) * 2;
		end
		if manageMyArmy == 0 and spawnMyEnemy == 0 then
			self.ESpawnTimer:Reset();
		end




		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then

				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					local ship = nil;
					ship = CreateActor("Brain Case");
					ship.Team = self:GetTeamOfPlayer(player);
					ship.Pos = Vector(self.LZ:GetRandomPoint().X+100,-200);
					MovableMan:AddActor(ship);
					self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime) * 2;
					self:SetPlayerBrain(ship, player);

				end

				local team = self:GetTeamOfPlayer(player);

				if spawn == 1 then

					local actor = {};
					for x = 0, math.ceil(math.random(3)) do
						local y = math.random();
						if y > 0.05 then
							actor[x] = CreateAHuman(self.AList[math.random(#self.AList)]);
							actor[x].Team = team;
							actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)]));
							actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)]));
							--actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
						else
							actor[x] = CreateACrab("Dreadnought");
							actor[x].Team = team;
						end
					end
					local ship = nil;
					local z = math.random();
					if z > 0.90 then
						ship = CreateACRocket("Drop Crate","Dummy.rte");
					elseif z > 0.80 then
						ship = CreateACRocket("Rocklet","Dummy.rte");
					elseif z > 0.60 then
						ship = CreateACDropShip("Drop Ship","Dummy.rte");
					elseif z > 0.40 then
						ship = CreateACDropShip("Drop Ship MK1","Coalition.rte");
					elseif z > 0.20 then
						ship = CreateACRocket("Rocket MK2","Coalition.rte");
					else
						ship = CreateACRocket("Rocket MK1","Coalition.rte");
					end
					for n = 0, #actor do
						ship:AddInventoryItem(actor[n]);
					end
					ship.Team = team;
					local w = math.random();
					if w > 0.8 then
						ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
					else
						ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
					end
					MovableMan:AddActor(ship);	
				end
			end
		end

		--Spawn the AI.
		if self.CPUTeam == nil then
			self.CPUTeam = Activity.NOTEAM;
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				if self:PlayerActive(player) and not(self:PlayerHuman(player)) then
					local team = self:GetTeamOfPlayer(player);
					self.CPUTeam = team;
				end
			end
		end

		if self.CPUTeam ~= Activity.NOTEAM and spawn == 2 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				local y = math.random();
				if y > 0.05 then
					actor[x] = CreateAHuman(self.AList[math.random(#self.AList)]);
					actor[x].Team = self.CPUTeam;
					actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)]));
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)]));
					--actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
				else
					actor[x] = CreateACrab("Dreadnought");
					actor[x].Team = self.CPUTeam;
					actor[x].AIMode = Actor.AIMODE_PATROL;
				end
			end
			local ship = nil;
			local z = math.random();
			if z > 0.90 then
				ship = CreateACRocket("Drop Crate","Dummy.rte");
			elseif z > 0.80 then
				ship = CreateACRocket("Rocklet","Dummy.rte");
			elseif z > 0.60 then
				ship = CreateACDropShip("Drop Ship","Dummy.rte");
			elseif z > 0.40 then
				ship = CreateACDropShip("Drop Ship MK1","Coalition.rte");
			elseif z > 0.20 then
				ship = CreateACRocket("Rocket MK2","Coalition.rte");
			else
				ship = CreateACRocket("Rocket MK1","Coalition.rte");
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			ship.Team = self.CPUTeam;
			local w = math.random();
			if w > 0.2 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			MovableMan:AddActor(ship);

		end

		--Win/Lose Conditions
		--There used to be a lot of stuff here.  Like we needed it!  ;P

	else
		self.StartTimer:Reset();
	end
end